#include <stdio.h>
#include <math.h>
#define n 10000
#define scale 0.454
int   num[n];
float x[n],y[n],cali,cali4,cal[4];
float dx[n],dy[n],dz[n],dm[n],ds[n];
float bx[n],by[n],bz[n],bm[n],bs[n];
float sec2;
FILE *fp;
main(int ac, char **av)
{
  int i,j,k,kd,kb,m;
  float z,x1,x2,x3,x4,x5,x6;
  char a[200],f1[30],f2[30],head[72][80];
  sec2=1./(scale*scale);
  if(ac<2){ printf("\n\t *** comp *.als, *.cat ***\n");
            printf("\n\tch_dao p5924_0188_1\n\n");
            exit(0);
          }
  strcpy(f1,av[1]); for(i=0;i<strlen(f1);i++)if(f1[i]=='.')break; f1[i]=0;
  sprintf(f2,"%s.fit",f1); fp=fopen(f2,"rb");
  if(!fp){ printf("\n\t%s not found!\n",f2); exit(0); }
  fread(head,72,80,fp); fclose(fp);
  k=indexpos(head,"CALIA73 ",72);
  if(k==72){ printf("\t not a cali_A73  file: %s\n",f2); exit(0); }
  sscanf(&head[k][15],"%f",&cali);
  for(i=0;i<4;i++)if(head[k+i+1][28]!=32)sscanf(&head[k+i+1][15],"%f",&cal[i]);
                  else cal[i]=cali;

  sprintf(f2,"%s.cat",f1);  fp=fopen(f2,"r");
  if(!fp){ printf("\n\t%s not found!\n",f2); exit(0); }
  i=0;
l10:
  fgets(a,200,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(a,"%d",&num[i]);
  sscanf(&a[33],"%f %f %f %f",&x[i],&y[i],&x1,&x2);
  if(x[i]==0.){ x[i]=x1; y[i]=x2; }
  i++; goto l10;
l20:
  fclose(fp);  m=i;
  for(i=0;i<m;i++)dx[i]=0.;
  for(i=0;i<m;i++)dy[i]=0.;
  for(i=0;i<m;i++)dz[i]=0.;
  for(i=0;i<m;i++)dm[i]=0.;
  for(i=0;i<m;i++)ds[i]=0.;

  sprintf(f2,"%s.als",f1); fp=fopen(f2,"r");
  fgets(a,200,fp); fgets(a,200,fp); fgets(a,200,fp);
  kd=0;
l30:
  fgets(a,200,fp); if(feof(fp))goto l40;
  sscanf(a,"%d %f %f %f %f",&j,&x1,&x2,&x3,&x4);
  for(i=0;i<m;i++)if(num[i]==j)break;
  z=(x1-x[i])*(x1-x[i])+(x2-y[i])*(x2-y[i]);
  if(z<sec2 && x3>5. && x3<30.){
    if(x1< 2048 && x2>=2016)cali4=cal[0];
    if(x1< 2048 && x2< 2016)cali4=cal[1];
    if(x1>=2048 && x2>=2016)cali4=cal[2];
    if(x1>=2048 && x2< 2016)cali4=cal[3];
    x3+=cali4;
    dx[i]=x1; dy[i]=x2; dz[i]=sqrt(z)*scale; dm[i]=x3; ds[i]=x4;  kd++;
  }
  goto l30;
l40:
  fclose(fp);
  printf("%d/%d matched DAO\n",kd,m);

  for(i=0;i<m;i++)bx[i]=0.;
  for(i=0;i<m;i++)by[i]=0.;
  for(i=0;i<m;i++)bz[i]=0.;
  for(i=0;i<m;i++)bm[i]=0.;
  for(i=0;i<m;i++)bs[i]=0.;

  sprintf(f2,"%s.psfcat",f1);
  fp=fopen(f2,"r"); if(!fp){ printf("%s not found!\n",f2); exit(0); }
  kb=0;
l50:
  fgets(a,200,fp); if(feof(fp))goto l60;
  if(a[0]=='#')goto l50;
  sscanf(a,"%d %f %f %f %f %f %f",&i,&x1,&x2,&x5,&x6,&x3,&x4);
  if(x3>30.)goto l50;
  x5=sec2;
  for(i=0;i<m;i++){
    z=(x1-x[i])*(x1-x[i])+(x2-y[i])*(x2-y[i]);
    if(z<x5){ x5=z; j=i; }
  }
  if(x5==sec2)goto l50;
  if(x1< 2048 && x2>=2016)cali4=cal[0];
  if(x1< 2048 && x2< 2016)cali4=cal[1];
  if(x1>=2048 && x2>=2016)cali4=cal[2];
  if(x1>=2048 && x2< 2016)cali4=cal[3];
  x3+=cali4;
  bx[j]=x1; by[j]=x2; bz[j]=sqrt(x5)*scale; bm[j]=x3; bs[j]=x4;  kb++;
  goto l50;
l60:
  fclose(fp);
  printf("%d/%d matched ber\n",kb,m);
  
  sprintf(f2,"%s.2psf",f1); fp=fopen(f2,"w");
  fprintf(fp,"# 1 number          i5\n");
  fprintf(fp,"# 2 USL_X           f8.2\n");
  fprintf(fp,"# 3 USL_Y           f8.2\n");
  fprintf(fp,"# 4 DAO_psf_X       f8.2\n");
  fprintf(fp,"# 5 DAO_psf_Y       f8.2\n");
  fprintf(fp,"# 6 DAO_psf_XY_err  f5.2   (arcsec)\n");
  fprintf(fp,"# 7 DAO_psf_mag     f7.3\n");
  fprintf(fp,"# 8 DAO_psf_magerr  f6.3\n");
  fprintf(fp,"# 9 Ber_psf_X       f8.2\n");
  fprintf(fp,"#10 Ber_psf_Y       f8.2\n");
  fprintf(fp,"#11 Ber_psf_XY_err  f5.2   (arcsec)\n");
  fprintf(fp,"#12 Ber_psf_mag     f7.3\n");
  fprintf(fp,"#13 Ber_psf_magerr  f6.3\n");
  for(i=0;i<m;i++)fprintf(fp,"%5d%8.2f%8.2f%8.2f%8.2f%5.2f%7.3f%6.3f%8.2f%8.2f%5.2f%7.3f%6.3f\n",
  num[i],x[i],y[i],dx[i],dy[i],dz[i],dm[i],ds[i],bx[i],by[i],bz[i],bm[i],bs[i]);
  fprintf(fp,"# USL %d     DAO  %d     Bertin %d\n",m,kd,kb);
  fclose(fp);
  printf("%s produced!\n",f2);
}
